#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_width1  1
#property indicator_color2  SteelBlue
#property indicator_width2  2
#property indicator_color3  OrangeRed
#property indicator_width3  2



extern string     Instrument1    = "XAUUSD";
extern double     Open1          = 1600.0;
extern string     Instrument2    = "XAGUSD";
extern double     Open2          = 32.000;
extern bool       posCorr        = true;
extern double     maPeriodS      = 9.0;
extern double     maPeriodF      = 50.0;
extern bool       maVisible      = true;

//
//
//
//
//
int    symbolCount;
double sp[], spMAS[], spMAF[];
double investment=1000;
double leverage, lotPrice;
double accountType;
double start1, start2, now1, now2;
double lot1, lot2, amount1, amount2;
double point1, point2;
double value1, value2;
string symbols[];
string baseInstrument1, baseInstrument2;
bool   x1, x2;
string prefix      = "NA";
string suffix      = "NA";

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   getSymbolsList();   
   symbolCount = ArraySize(symbols);
   if (symbolCount<1) return(-1);
   baseInstrument1 = StringUpperCase(Instrument1);
   baseInstrument2 = StringUpperCase(Instrument2);
   getPrefixSuffix(prefix, suffix);
   Instrument1 = StringConcatenate(prefix,baseInstrument1,suffix);
   Instrument2 = StringConcatenate(prefix,baseInstrument2,suffix);
   if (StringFind(baseInstrument1,"X",0) == 0) x1=True;
   if (StringFind(baseInstrument2,"X",0) == 0) x2=True;
   getAccountType(accountType);
   SetIndexBuffer(0,sp);
   SetIndexBuffer(1,spMAS);
   SetIndexBuffer(2,spMAF);
   IndicatorShortName ("sp "+baseInstrument1+"("+DoubleToStr(Open1,4)+") "+baseInstrument2+"("+DoubleToStr(Open2,4)+") posCorr="+posCorr+ " / ");
   
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,k,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(sp,0)  != Bars) ArrayResize(sp,  Bars);
         if (ArrayRange(spMAS,0)!= Bars) ArrayResize(spMAS,Bars);
         if (ArrayRange(spMAF,0)!= Bars) ArrayResize(spMAF,Bars);


   //
   //
   //
   //
   //
        
   for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      double temp1 = (iClose(Instrument1,0,i)-Open1) / MarketInfo(Instrument1,MODE_POINT) * RealTickValue(Instrument1);
      double temp2 = (iClose(Instrument2,0,i)-Open2) / MarketInfo(Instrument2,MODE_POINT) * RealTickValue(Instrument2);
      temp1 = temp1 * ( RealTickValue(Instrument2) / (RealTickValue(Instrument1) + RealTickValue(Instrument2)));
      temp2 = temp2 * ( RealTickValue(Instrument1) / (RealTickValue(Instrument1) + RealTickValue(Instrument2)));
      if (posCorr)
      {     
         double temp = temp1 - temp2;
      }else{
                temp = temp1 + temp2;
      }
      sp[i] = NormalizeDouble(temp,2);
   }
   if (maVisible)
   {
         for(i=limit; i>=0; i--) 
         {
            spMAS[i]  = NormalizeDouble(iMAOnArray(sp,0,maPeriodS,0,MODE_EMA,i),2);
            spMAF[i]  = NormalizeDouble(iMAOnArray(sp,0,maPeriodF,0,MODE_EMA,i),2);
         }
   }   

   
   
   //
   //
   //
   //
   //
   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
void getSplits()
{
   lot1 = RealTickValue(Instrument2) / (RealTickValue(Instrument1) + RealTickValue(Instrument2));
   lot2 = RealTickValue(Instrument1) / (RealTickValue(Instrument1) + RealTickValue(Instrument2));
   Print("lot1="+DoubleToStr(lot1,2)+" lot2="+DoubleToStr(lot2,2));
   point1 = MarketInfo(Instrument1,MODE_POINT);
   point2 = MarketInfo(Instrument2,MODE_POINT);
}

//
//
//
//
//

double RealTickValue(string contract) //sometimes MT4 tick values change
{
   double res;
   //res= MarketInfo(contract,MODE_TICKVALUE) / (MarketInfo(contract,MODE_TICKSIZE)/MarketInfo(contract,MODE_POINT));
   res= (MarketInfo(contract,MODE_TICKVALUE)*MarketInfo(contract,MODE_POINT))/MarketInfo(contract,MODE_TICKSIZE);
return(res);
}





//
//
//
//
//

#import "kernel32.dll"
    int _lclose (int);
    int _lopen  (string,int);
    int _llseek (int,int,int);
    int _lread  (int,string,int);
#import
#define sectorSize  1936
#define HFILE_ERROR -1


//
//
//
//
//

void getSymbolsList()
{
   ArrayResize(symbols,0);
   int fileHandle = _lopen(TerminalPath()+"\\history\\"+AccountServer()+"\\symbols.raw",0);
   if (fileHandle == HFILE_ERROR) return;
    
   //
   //
   //
   //
   //

   for(int i=0;; i++)
   {
      _llseek(fileHandle, i * sectorSize, 0);
      string symbolName = "123456789012";       
                        if (_lread (fileHandle, symbolName, 12) != 12) break;
             symbolName = StringSubstr(symbolName, 0);

             //
             //
             //
             //
             //

      ArrayResize(symbols,i+1); symbols[i] = StringTrimLeft(StringTrimRight(symbolName));
   } 
   _lclose(fileHandle);
}

//
//
//
//
//

bool findSymbol(string findWhat)
{
   int  limit = ArraySize(symbols);
         for(int i=0; i<limit; i++) if (findWhat==symbols[i]) break;
   return(i<limit);      
}
//
//
//
//
//

void getPrefixSuffix(string& prefix, string& suffix)
{ 
   getSymbolsList();   
   int limit = ArraySize(symbols);
   if (limit<1) return;
         prefix="";
         suffix="";
   
   //
   //
   //
   //
   //
   
   for(int i=0; i<limit; i++)
   {
      string symbolName = symbols[i];
             int pos = StringFind(symbolName,"EURUSD",0);
             if (pos > -1)
             {
                if (pos>0)                         prefix = StringSubstr(symbolName,0,pos);
                if ((pos+6)<StringLen(symbolName)) suffix = StringSubstr(symbolName,(pos+6),0);
                break;
             }
   } 
}

//
//
//
//
//

void getAccountType(double& accountType)
{ 
   getSymbolsList();   
   int limit = ArraySize(symbols);
   if (limit<1) return;
   
   //
   //
   //
   //
   //
   
   for(int i=0; i<limit; i++)
   {
      string symbolName = symbols[i];
             int pos = StringFind(symbolName,"EURUSD",0);
             if (pos > -1)
             {
                accountType = MarketInfo(symbolName,MODE_LOTSIZE);
                break;
             }
   } 
}

//
//
//
//
//
string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   return(s);
}

